using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using System.Text;

namespace Platform
{
    class Bullet : Actor 
    {
        private Texture2D[] smokeTexture;
        private int timer;
        private float alphaperframe;
        private Vector4 tint;
        private double init;

        public Bullet(Game1 g, Texture2D[] tex, SpriteBatch spr, Vector2 vel,Player p)
            : base(g, tex, spr)
        {
            velocity = vel;
            friction = 1f;
            position = p.shot;
            state = states.IN_AIR;
            timer = 200;
            smokeTexture = game.smokeText;
            alphaperframe = 1f / (float)timer;
            tint = Vector4.One;
        }

        protected override void calculatePos()
        {
            switch (state)
            {
                case states.HIT:
                    init = game.gameRandom.NextDouble();
                    velocity = new Vector2((float)Math.Sin(game.time+init), (float)(-0.3 * game.gameRandom.NextDouble()));
                    state = states.SMOKE;
                    break;

                case states.SMOKE:
                    if (timer-- == 0)
                        state = states.DELETE;
                    tint.W -= alphaperframe;
                    velocity.X = (float)(float)Math.Sin(game.time+init);
                    tintColor = new Color(tint);
                    break;
            }
          
        }

        public override void checkCollision(Actor a)
        {
        }
        
        protected override void outofBoundsFunc(int i)
        {
            switch (i)
            {
                case 1:
              
                    break;
                case 2:
                    state = states.DELETE;
                    break;
                case 3:
                    state = states.DELETE;
                    break;
                case 4:
                    state = states.DELETE;
                    break;
                default:
                    break;
            }
        }
    }
}
