using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using System.Text;

namespace Platform
{
    public class CollideBackground
    {
        public bool[,] collisionlist;
        Texture2D texture;
        SpriteBatch sprite;
        Game1 game;

            public CollideBackground(Game1 g,Texture2D text,SpriteBatch s)
            {
                game = g;
                texture = text;
                sprite = s;
                collisionlist = new bool[texture.Width, texture.Height];

                int[] tmp = new int[texture.Width*texture.Height];
                texture.GetData<int>(tmp);

                for (int i = 0; i < texture.Width; i++)
                {
                    for (int j = 0; j < texture.Height; j++)
                    {
                        if (tmp[i + j * texture.Width] > 0)
                        {
                            tmp[i + j * texture.Width] = int.MinValue;
                            collisionlist[i, j] = false;
                        }
                        else
                        {
                            collisionlist[i, j] = true;
                            tmp[i + j * texture.Width] = int.MaxValue;
                            
                        }
                    }
                }

               // texture.SetData<int>(tmp);
            }

        public void draw()
        {
            sprite.Begin(SpriteBlendMode.AlphaBlend);
            sprite.Draw(texture, Vector2.Zero, Color.White);
            sprite.End();
        }

        public bool intersctionTest(Vector2 v)
        {

            if (float.IsNaN(v.X) || float.IsNaN(v.Y))
                return false;
            else
                 return collisionlist[(int)MathHelper.Clamp(v.X,0,799),(int)MathHelper.Clamp(v.Y,0,599)];

        }
    }
}
