using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using System.Text;


namespace Platform
{
    class Enemy : Actor
    {
        Player player;
        private float speed;
        private int life;
        private int fullLife;

        public Enemy(Game1 g, Texture2D[] tex, SpriteBatch spr,Player p)
            : base(g, tex, spr)
        {
            player = p;
            speed = (float)(0.001 * game.gameRandom.NextDouble());
            fullLife = 5;
            life = fullLife;        
        }

        protected override void calculatePos()
        {
            switch(state){
                case states.ON_GROUND:
                    acc.X = (player.position.X - position.X) * speed;
                    break;
            }

        }

        public override void checkCollision(Actor a)
        {
            if (a.GetType().Equals(typeof(Bullet)))
            {
                if (((spherepos - a.spherepos).LengthSquared() < (sphererad + a.sphererad)) && a.state==states.IN_AIR)
                {
                        a.state = states.HIT;
                        if (life-- == 0)
                        {
                            position.X = (float)(game.gameRandom.NextDouble() * game.ScreenW);
                            position.Y = 0;
                            state = states.IN_AIR;
                            velocity = Vector2.Zero;
                            life = fullLife;
                        }
                        
                }
            }
        }



        protected override void outofBoundsFunc(int i)
        {
            switch (i)
            {
                case 1:
                    state = states.ON_GROUND;
                    while (game.back.intersctionTest(position + new Vector2(0,textureArr[0].Height))) position.Y--; 
                    break;
                case 2:
                    velocity.X = 0;
                    position.X = game.ScreenW - texture[0].Width;
                    break;
                case 5:
                     state = states.IN_AIR;
                     break;
                default:
                    break;

            }
        }

    }
}
