using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using System.Text;

namespace Platform
{
    class Player : Actor
    {
        public Texture2D[] rightTextArr;
        public Texture2D[] leftTextArr;
        public Vector2 shot;
        private bool right;

        public bool goingRight
        {
            get
            {
                return right;
            }
        }

        public Player(Game1 g,Texture2D[] tex,SpriteBatch spr):base(g,tex,spr)
        {
            right = true;
            shot = position;
        }

        protected override void calculatePos()
        {
            if (right)
            {
                shot.X = position.X + 15f;
                shot.Y = position.Y + 20f;
 
            }
            else
            {
                shot.X = position.X + textureArr[0].Width - 25f;
                shot.Y = position.Y + 20f;

            }
            /*
            if (bursttime < 20)
            {
               bursttime++;
               if (bursttime == 20) burst = 10;
            }
             */             
        }

        public override void checkCollision(Actor a)
        {
            if (a.GetType().Equals(typeof(Enemy)))
            {
                if ((spherepos - a.spherepos).LengthSquared() < (sphererad + a.sphererad))
                {
                    position.X = (float)(game.gameRandom.NextDouble() * game.ScreenW);
                    position.Y = 0;
                    state = states.IN_AIR;
                    velocity = Vector2.Zero;
                }
            }
            //velocity = -velocity;
        }

        protected override void outofBoundsFunc(int i)
        {
            switch (i)
            {
                case 1:
                    state = states.ON_GROUND;
                    while (game.back.intersctionTest(position + new Vector2(0,textureArr[0].Height))) position.Y--; 
                    break;
                case 2:
                    velocity.X = 0;
                    position.X = game.ScreenW - texture[0].Width;
                    break;
                case 3:
                    velocity.X = 0;
                    position.X = 0;
                    break;
                case 5:
                    state = states.IN_AIR;
                    break;
                default:
                    break;
            }
        }

        public void turnLeft()
        {
            if (right)
            {
                textureArr = leftTextArr;
                right = false;
            }
        }

        public void turnRight()
        {
            if (!right)
            {
                textureArr = rightTextArr;
                right = true;
            }
        }

    }
}
